# MP2021-22_Smutny-Jan_Algoritmizace-s-Micro-bit

Vše prováděno podle mého nejlepšího vědomí a svědomí.
Veškeré repositáře budou později přesunuty do microbit organizace (kvůli screenů bloků jsem v repozitářích nechal main.* soubory... **v organizaci nebudou**)

❓ a  **tučným** písmem značím otázky, na které se chci zeptat.
💠 a *kurzívou* značím tipy speciálně pro Míšu

#### Změny po 15.3.
- Enum u malování přejmenován na „MoveDirection“. Přidány definice vyrenderovaného stringu (//% block="Nahoru") 
- Předělání alarmu


[Caesarova šifra 1/2](#caesarova-šifra-část-12)\
[Caesarova šifra 2/2 (s „hackováním“)](#caesarova-šifra-část-22)\
[Malování](#malování)\
[Světelná závora](#světelná-závora)\
[Alarm](#alarm)\
[Hlasování 1/2 (volič)](#hlasování-12-volič)\
[Hlasování 2/2 (server)](#hlasování-22-server)\
[Balancování](#balancování)\
[Mikádo/hlídač věcí](#mikádohlídač-věcí)

# Caesarova šifra (část 1/2)
Tato úloha (bez ohledu na obtížnost) tvoří první část ze dvou. V této části si žáci vyzkouší/vytvoří algoritmus pro zašifrovaní a dešifrování textu Caesarovou šifrou. V druhé části si pak žáci vyzkouší, k čemu by šifra mohla být: budou si přes bezdrátovou komunikaci zašifrované texty posílat. Rozšíření zašifruje pouze následující znaky: "a", "b", "c", "d", "e", "f", "g", "h", "i", "j", "k", "l", "m", "n", "o", "p", "q", "r", "s", "t", "u", "v", "w", "x", "y", "z". Znaky s diakritikou se převedou na znaky bez diakritiky (ě -> e, č -> c). Pokud bude text obsahovat jiné znaky, nechají se, jak jsou.
*💠 Za mě je důležité, aby si žáci vyzkoušeli záporný posuv a záporné a kladné přetečení. Dále je důležité, že microbit neumí zobrazovat znaky s diakritikou. Nevyhodí chybu, ale jednoduše znak nezobrazí!💠*

## Nižší ročník (jednodušší varianta)
Jde jen o vyzkoušení šifry a správné „natahání“ již zhotovených bloků do Startu. Žáci si poté mohou měnit text a posun.
### Rozšíření
#### Zašifruj
- Zašifruje zadaný text zadaným klíčem
- Parametry:
    - text k zašifrování (text)
    - klíč (posun) - může být kladný i záporný (číslo)
- Návratová hodnota: zašifrovaný text (text)

#### Dešifruj
- Dešifruje zadaný text zadaným klíčem
- Parametry:
    - text k dešifrování (text)
    - klíč (posun) - může být kladný i záporný (číslo)
- Návratová hodnota: dešifrovaný text (text)

### Možné řešení:


![Bloky z rozšíření v bloku „Při startu“](https://github.com/pslib-cz/MP2021-22_Smutny-Jan_Algoritmizace-s-Micro-bit/blob/main/images/caesar%20cipher%20pt1/easy-version.png?raw=true)


https://github.com/SmutnyJan/pxt-caesar-cipher-extension
https://github.com/microbit-cz/pxt-caesarova-sifra-rozsireni-nizsi-rocnik

## Vyšší ročník (těžší varianta)
Jedná se o trochu složitější variantu. V rozšíření jsou k dispozici opět dva bloky, ovšem tentokrát zašifrují/dešifrují pouze jeden znak (**❓Jak zajistím, aby měl jako vstup pouze jeden znak a ne string? Nyní to řeším tak, že beru vždy první znak ze stringu, což není zrovna šťastné řešení❓**). Žáci mají tedy za úkol navrhnout řešení, které by zadaný text „rozkouskovalo“ na jednotlivé znaky, které by rozšíření zašifrovalo/dešifrovalo a poté ze znaků opět poskládat výsledný text.
*💠 Za zmínku stojí, že se sekce „funkce“ v prostředí makecode skrývá pod možností „Rozšířené“ (je potřeba kliknou na šipku).💠*


### Rozšíření
#### Zašifruj
- Zašifruje zadaný znak zadaným klíčem
- Parametry:
    - znak k zašifrování (znak)
    - klíč (posun) - může být kladný i záporný (číslo)
- Návratová hodnota: zašifrovaný znak (znak)

#### Dešifruj
- Dešifruje zadaný znak zadaným klíčem
- Parametry:
    - znak k dešifrování (znak)
    - klíč (posun) - může být kladný i záporný (číslo)
- Návratová hodnota: dešifrovaný znak  (znak)

### Možné řešení:

Vytvoříme si funkci „Zasifruj“, která si jako parametry bere text k zašifrování a posun (klíč). Ve funkci nalezneme smyčku s iterační („opakovací“) proměnnou „i“, která bude reprezentovat, na jakém znaku se zrovna nacházíme a z toho důvodu bude nabývat hodnoty 0 (první znak) až délka vloženého textu - 1 (začínáme od 0, proto musíme odečíst 1). Nyní si vytvoříme proměnnou „konecnyText“ (to v blokovém kódu není vidět) a proměnnou nastavíme na hodnotu, kterou doteď měla a přidáme k ní zašifrovaný znak, který získáme tak, že si zavoláme z rozšíření blok „Zašifruj znak“, kterému předáme posun (z parametru) a písmeno ve vloženém textu (z parametru) na aktuální pozici (tu máme uloženou v proměnné „i“). Po provedení celé smyčky jednoduše z naší funkce vrátíme proměnnou „konecnyText“.

![Řešení metody pro zašifrování](https://github.com/pslib-cz/MP2021-22_Smutny-Jan_Algoritmizace-s-Micro-bit/blob/main/images/caesar%20cipher%20pt1/zasifruj.png?raw=true)

Dešifrování funguje velice podobně jako zašifrování s tím rozdílem, že nevoláme z rozšíření blok Zašifruj ale Dešifruj.

![Řešení metody pro dešifrování](https://github.com/pslib-cz/MP2021-22_Smutny-Jan_Algoritmizace-s-Micro-bit/blob/main/images/caesar%20cipher%20pt1/desifruj.png?raw=true)

Nakonec můžeme funkci použít v bloku „Při startu“.

![Přiklad použití vytvořené funkce v bloky „Při startu“](https://github.com/pslib-cz/MP2021-22_Smutny-Jan_Algoritmizace-s-Micro-bit/blob/main/images/caesar%20cipher%20pt1/usage.png?raw=true)

https://github.com/SmutnyJan/pxt-advanced-caesar-cipher
https://github.com/microbit-cz/pxt-caesarova-sifra-rozsireni-vyssi-rocnik

# Caesarova šifra (část 2/2)
Jedná se o druhou část Caesarovy šifry, ve které budou mít žáci za úkol bezdrátově poslat zašifrovaný text na jiný microbit, kde přijatý text dešifrují. Ke splnění tedy potřebují hotový projekt (ať už jednodušší nebo těžší variantu) Caesarovy šifry. Žáci se by měli pochopit hlavně význam šifrování.
*💠 Předtím, než žáci začnou s implementací posílání textu bych navrhoval, aby si vyzkoušeli, jak probíhá posílání běžného textu. Dojde jim pak, že jejich zprávu si může kdokoli přečíst => zde přichází šifrování. Dále bych navrhoval, aby se žáci rozdělili do skupin, aby si neodchytávali příliš mnoho textů (v microbitu budou skupiny reprezentovat skupinu rádia). Microbit totiž posílá veškeré zprávy broadcastem.💠*

## Nižší ročník (jednodušší varianta)
Každý microbit by měl fungovat jako vysíláč a zároveň jako přijímač, což zní možná složitěji, než ve skutečnosti je. Nenapadá mě, jak řešení okomentovat, takže asi bude nejlepší, když vše vysvětlím na kódu. K této úloze je potřeba pouze rozšíření z minulé úlohy, aby správně fungovala Caesarova šifra.
### Rozšíření
#### Zašifruj
- Zašifruje zadaný text zadaným klíčem
- Parametry:
    - text k zašifrování (text)
    - klíč (posun) - může být kladný i záporný (číslo)
- Návratová hodnota: zašifrovaný text (text)

#### Dešifruj
- Dešifruje zadaný text zadaným klíčem
- Parametry:
    - text k dešifrování (text)
    - klíč (posun) - může být kladný i záporný (číslo)
- Návratová hodnota: dešifrovaný text (text)

### Možné řešení:

Nejdřívě si v bloku „při startu“ zvolíme skupinu rádia. Můžeme volit hodnoty od 0 do 255. Každá skupina žáků bude mít své vlastní číslo, které do tohoto bloku vloží, aby nedocházelo k tomu, že budou přicházet na jeden microbit zprávy od všech ostatních. 

![Nastavení skupiny rádia](https://github.com/pslib-cz/MP2021-22_Smutny-Jan_Algoritmizace-s-Micro-bit/blob/main/images/caesar%20cipher%20pt2/setup.png?raw=true)

Dále si nastavíme odesílání textu. Text i posun může být samozřejmě libovolný.

![Nastavení odesílání textu](https://github.com/pslib-cz/MP2021-22_Smutny-Jan_Algoritmizace-s-Micro-bit/blob/main/images/caesar%20cipher%20pt2/sendtext.png?raw=true)

Jako poslední si nastavíme přijímání zašifrovaného textu, který si dešifrujeme. POZOR: úmyslně jsem dal do zašifrování posun 5 a do dešifrování posun 2. Takto se mi text dešifruje samozřejmě ŠPATNĚ a vznikne blbost. Klíče musí být stejné a žáci si je musí říct někde „mimo“ (symetrické šifrování). Ideální počet žáků ve skupině jsou tedy 3 (jeden posílá text, jeden ví správný posun a tím pádem se mu podaří dešifrovat text a druhý ho neví a jen to zkouší)

![Nastavení odesílání textu](https://github.com/pslib-cz/MP2021-22_Smutny-Jan_Algoritmizace-s-Micro-bit/blob/main/images/caesar%20cipher%20pt2/receivetext.png?raw=true)

*💠 Zde se nabízí poměrně jednoduchý úkol: nechat žáky změnit vstup, při kterém se odešle text. Poměrně dost jednoduché.💠*

https://github.com/SmutnyJan/pxt-caesar-cipher-extension
https://github.com/microbit-cz/pxt-caesarova-sifra-rozsireni-nizsi-rocnik

## Vyšší ročník (těžší varianta)
Zadání pro vyšší ročník je úplně stejné, jako pro nižší, s tím rozdílem, že žáci využijí své naprogramováné funkce z předchozí úlohy místo bloků z rozšíření. 

### Rozšíření
#### Zašifruj
- Zašifruje zadaný znak zadaným klíčem
- Parametry:
    - znak k zašifrování (znak)
    - klíč (posun) - může být kladný i záporný (číslo)
- Návratová hodnota: zašifrovaný znak (znak)

#### Dešifruj
- Dešifruje zadaný znak zadaným klíčem
- Parametry:
    - znak k dešifrování (znak)
    - klíč (posun) - může být kladný i záporný (číslo)
- Návratová hodnota: dešifrovaný znak  (znak)

### Možné řešení:

Začínáme v projektu z minula. Opět si zvolíme nejdříve skupinu rádia, které bude záviset na skupinách vytvořených žáky a která může nabývat hodnot od 0 do 255.

 ![Nastavení skupiny rádia](https://github.com/pslib-cz/MP2021-22_Smutny-Jan_Algoritmizace-s-Micro-bit/blob/main/images/caesar%20cipher%20pt2/setup.png?raw=true)

K odesílání adresy využijeme funkci, kterou jsme vytvořili v první části.

![Nastavení odesílání textu](https://github.com/pslib-cz/MP2021-22_Smutny-Jan_Algoritmizace-s-Micro-bit/blob/main/images/caesar%20cipher%20pt2/sendtext-advanced.png?raw=true)

V moment, kdy na náš microbit naopak někdo pošle text, přichází na řadu funkce k dešifrování.

![Nastavení odesílání textu](https://github.com/pslib-cz/MP2021-22_Smutny-Jan_Algoritmizace-s-Micro-bit/blob/main/images/caesar%20cipher%20pt2/receivetext-advanced.png?raw=true)
 
*💠 Úkol na změnu vstupu se nejspíš hodí i sem...💠*

https://github.com/SmutnyJan/pxt-advanced-caesar-cipher
https://github.com/microbit-cz/pxt-caesarova-sifra-rozsireni-vyssi-rocnik

# Malování
V této úloze si žáci vyzkouší za pomocí mictobitu „malovat“ na LED 5×5 pole, které na základním microbitu je. K této úloze tedy také není potřeba nic navíc. Součástí úlohy bude hýbání kurzorem, překreslení LEDky (rozsvícení, zhasnutí), smazaní celé kresby a vypnutí/zapnutí blikání kurzoru.

## Nižší ročník (jednodušší varianta)
Varianta pro nižší ročník bude obsahovat již předpřipravené bloky, které budou muset žáci umístit do správných (smysluplných) vstupů. 

### Rozšíření
#### Překreslit bod
- Překreslí aktuální bod
- Bez parametrů
- Bez návratové hodnoty

#### Vymazat kresbu
- Vypne všechny LED (uvedení do výchozího stavu)
- Bez parametrů
- Bez návratové hodnoty

#### Přepnout kurzor
- Zapne/vypne blikání kurzoru (pokud si bude někdo chtít kresbu prohlédnout, mohl by kurzor překážet)
- Bez parametrů
- Bez návratové hodnoty
 
#### Blikat kurzorem
- Problikne kurzorem (umístí se do smyčky „opakuj stále“)
- Bez parametrů
- Bez návratové hodnoty

#### Pohyh dolu/nahoru/doleva/doprava
- Pohne kurzorem na danou stranu
- Parametry:
    - směr (enum)
- Bez návratové hodnoty

https://github.com/SmutnyJan/pxt-drawing
https://github.com/microbit-cz/pxt-malovani-rozsireni-nizsi-rocnik

### Možné řešení
Jediné, co je potřeba udělat, je zvolit vhodné vstupy, aby se nám celé malování lépe ovládalo. Úloha bude ale samozřejmě fungovat při jakýchkoli vstupech.

*💠 Zde by učitel mohl nechat žáky zamyslet se, kam by bylo vhodné umístit blikání kurzoru, když se provádí pořád dokola.💠*
Nejdříve si tedy vezmeme blok pro blikání kurzoru, který musí být bezpodmínečně ve smyčce „opakuj stále“.

![Blikání kurzoru](https://github.com/pslib-cz/MP2021-22_Smutny-Jan_Algoritmizace-s-Micro-bit/blob/main/images/drawing/cursorflash-easyversion.png?raw=true)

Zbylé bloky můžeme dát do jakýchkoli druhů vstupů. Já jsem pro nižší ročník zvolil naklápění microbitu a mačkání tlačítek/loga.

Smazaní kresby:

![Smazání kresby](https://github.com/pslib-cz/MP2021-22_Smutny-Jan_Algoritmizace-s-Micro-bit/blob/main/images/drawing/clearleds-easyversion.png?raw=true)

Překreslení LEDky:

![Překreslení LEDky](https://github.com/pslib-cz/MP2021-22_Smutny-Jan_Algoritmizace-s-Micro-bit/blob/main/images/drawing/redraw-easyversion.png?raw=true)

Zapnutí/vypnutí kurzoru:

![Zapnutí/vypnutí kurzoru](https://github.com/pslib-cz/MP2021-22_Smutny-Jan_Algoritmizace-s-Micro-bit/blob/main/images/drawing/tooglecursor-easyversion.png?raw=true)

Pohyb kurzoru:

![Pohyb dolu](https://github.com/pslib-cz/MP2021-22_Smutny-Jan_Algoritmizace-s-Micro-bit/blob/main/images/drawing/movedown-easyversion.png?raw=true)

![Pohyb nahoru](https://github.com/pslib-cz/MP2021-22_Smutny-Jan_Algoritmizace-s-Micro-bit/blob/main/images/drawing/moveup-easyversion.png?raw=true)

![Pohyb doleva](https://github.com/pslib-cz/MP2021-22_Smutny-Jan_Algoritmizace-s-Micro-bit/blob/main/images/drawing/moveright-easyversion.png?raw=true)

![Pohyb doprava](https://github.com/pslib-cz/MP2021-22_Smutny-Jan_Algoritmizace-s-Micro-bit/blob/main/images/drawing/moveright-easyversion.png?raw=true)

## Vyšší ročník (složitejší varianta)
Ve variantě pro vyšší ročník budou mít žáci souřadnice již ve své vlastní režii. Nejzajímavější je to, jakým způsobem zajistit, že se kurzor přesune například na začátek řádku, pokud z řádku vyjedu. Žáci se budou tedy muset postarat o „přetékání“ kurzoru. K tomu je potřeba pochopit souřadnice na microbitu, které jsem se pokusil vysvětlit na následujícím obrázku:

![Popis os](https://github.com/pslib-cz/MP2021-22_Smutny-Jan_Algoritmizace-s-Micro-bit/blob/main/images/drawing/microbit.PNG?raw=true)


### Rozšíření
#### Překreslit bod
- Překreslí aktuální bod
- Bez parametrů
- Bez návratové hodnoty

#### Vymazat kresbu
- Vypne všechny LED (uvedení do výchozího stavu)
- Bez parametrů
- Bez návratové hodnoty

#### Přepnout kurzor
- Zapne/vypne blikání kurzoru (pokud si bude někdo chtít kresbu prohlédnout, mohl by kurzor překážet) na určitých souřadnicích 
- Parametry:
    - souřadnice X (číslo)
    - souřadnice Y (číslo)
- Bez návratové hodnoty
 
#### Blikat kurzorem
- Problikne kurzorem na daných souřadnicích (umístí se do smyčky „opakuj stále“)
- Parametry:
    - souřadnice X (číslo)
    - souřadnice Y (číslo)
- Bez návratové hodnoty

#### Pohyb
- Pohne kurzorem na danou souřadnici
- Parametry:
    - souřadnice X (číslo)
    - souřadnice Y (číslo)
- Bez návratové hodnoty

https://github.com/SmutnyJan/pxt-drawing-advanced
https://github.com/microbit-cz/pxt-malovani-rozsireni-vyssi-rocnik

### Možné řešení
Nejdřívě si v bloku „při startu“ vytvoříme proměnné x, y, které v sobě budou obsahovat aktuální souřadnice.

![Vytvoření proměnných](https://github.com/pslib-cz/MP2021-22_Smutny-Jan_Algoritmizace-s-Micro-bit/blob/main/images/drawing/initialsetup.png?raw=true)

Nyní si vezmeme blok „pořád dokola“, ve kterém realizujeme blikání kurzoru.
*💠 Zde by také nebylo špatné zeptat se žáků, kde by mohlo blikání být, když se provádí pořád dokola.💠*

![Blikání kurzoru](https://github.com/pslib-cz/MP2021-22_Smutny-Jan_Algoritmizace-s-Micro-bit/blob/main/images/drawing/cursorflash.png?raw=true)

Nyní si zvolíme vstupy pro pohybování kurzorem, vypnutí/zapnutí kurzoru, vymazání kresby a přepnutí „pixelu“ (rozsvícení/zhasnutí LEDky). Vybral jsem pro pohyb kurzoru dolů a překreslení bodu dotyk na pinu, který očividně funguje pouze tehdy, pokud jsem zároveň uzemněný (hádám). **❓Na konkrétní funkcionalitu se musím zeptat❓**

*💠 Každopádně tady vyvstává zajímavá možnost, aby byla informatika trošku propojena s fyzikou. Moc nevím, kdy se takové věci probírají, ale učitel fyziky by žákům mohl velice zjednodušeně vysvětlit, proč dotyk pinu nefunguje, když nejsou uzemnění (pokud to tak opravdu funguje :-D)💠*

Smazání kresby:

![Smazání kresby](https://github.com/pslib-cz/MP2021-22_Smutny-Jan_Algoritmizace-s-Micro-bit/blob/main/images/drawing/clearleds.png?raw=true)

Zapnutí/vypnutí blikání kurzoru:

![Blikání kurzoru](https://github.com/pslib-cz/MP2021-22_Smutny-Jan_Algoritmizace-s-Micro-bit/blob/main/images/drawing/cursorflash.png?raw=true)

Překreslení bodu (rozsvícení/zhasnutí)

![Blikání kurzoru](https://github.com/pslib-cz/MP2021-22_Smutny-Jan_Algoritmizace-s-Micro-bit/blob/main/images/drawing/redraw.png?raw=true)

Nyní jsou na řadě vstupy pro pohyb s kurzorem. 
*💠 Nejdříve bych začal s volbou vstupů („natahání“ do vývojového prostředí). Potom by mohl učitel nechat žáky zamyslet se, jak se budou souřadnice měnit, když půjdeme doprava (x se zvýší o 1), doleva (x se sníží o 1), nahoru (y - 1) a dolů (y + 1). Když na tohle žáci přijdou, můžou toto naprogramovat. V každém vstupu odekvátně upraví souřadnice a pak je vždy obě předají metodě pohyb. Při zkoušení programu by žáci měli přijít na to, že když vyjedou na konec pole a půjdou dále, kurzor zmizí. Zde by se učitel mohl zeptat, čím to je (odpověď by byla, že je souřadnice moc velká/malá => pokud jsem úplně vpravo a půjdu opět doprava, souřadnice X bude 5, což je mimo pole). Dalším úkolem tedy bude zajistit, že pokud vyjedu například z pole dolní stranou, kurzor se objeví na té horní.💠*

Pro pohyb nahoru musíme snížit proměnnou Y o 1. Když je ovšem Y 0, tak jsme na horní hraně a další pohyb nahoru by měl způsobit, že se kurzor přesune opět dolu. Tuto funkcionalitu zajistíme jednoduchým ifem. Y tedy snížíme o 1 a zkontrolujeme, že Y není menší než 0 (0 je minimum). Pokud je Y menší než 0 (jsme za hranou), tak Y nastavíme na 4 a tím pádem se vrátíme zpět dolů. Poté již můžeme zavolat blok z rozšíření.

![Pohyb nahoru](https://github.com/pslib-cz/MP2021-22_Smutny-Jan_Algoritmizace-s-Micro-bit/blob/main/images/drawing/moveup.png?raw=true)

Zbytek funguje na stejném principu. U pohybu vpravo, u kterého se zvyšuje X, je potřeba kontrolovat, zda-li není X větší než 4. Pokud je, tak se nastaví X na 0.

![Pohyb vpravo](https://github.com/pslib-cz/MP2021-22_Smutny-Jan_Algoritmizace-s-Micro-bit/blob/main/images/drawing/moveright.png?raw=true)

Pohyb dolů funguje podobně, jako pohyb nahoru, ale mezní případ zde je, když je Y větší než 4. V tomto případě musí kurzor skočit nahoru a tím pádem nastavíme Y na 0.

![Pohyb dolů](https://github.com/pslib-cz/MP2021-22_Smutny-Jan_Algoritmizace-s-Micro-bit/blob/main/images/drawing/movedown.png?raw=true)

No a u pohybu vlevo dojde k přeskočení na opačnou stranu v případě, že je X menší než 0. Když se toto stane, tak se X nastaví na 4. Poté opět můžeme volat metodu pro pohyb.

![Pohyb vlevo](https://github.com/pslib-cz/MP2021-22_Smutny-Jan_Algoritmizace-s-Micro-bit/blob/main/images/drawing/moveleft.png?raw=true)

# Světelná závora
Tato úloha bude velice zjednodušeně simulovat světelnou závoru. Tentokrát budeme mimo microbitu potřebovat ještě nějaký zdroj světla. Já jsem třeba používal baterku u telefonu. Ještě bych doporučoval rozšiřující modul (ten od pana Kazdy, **❓nikde jsem nenašel odkaz❓**) z důvodu jednodušší manipulace a zasazení do slotu. Není to ale nutnost. 

## Nižší ročník (jednodušší varianta)
Žáci si ve verzi pro nižší stupeň budou moci zvolit, co se má stát, když dojde k porušení světelné závory.

### Rozšíření
#### Zkalibruj a nastav toleranci %tol
- Spustí kalibraci a nastaví toleranci
- Parametry:
    - tolerance (číslo)
- Bez návratové hodnoty

#### Při porušení hladiny světla
- Zkontroluje, jestli došlo k porušení hladiny světla
- Parametry:
    - metoda
- Bez návratové hodnoty

https://github.com/SmutnyJan/pxt-light-gate
https://github.com/microbit-cz/pxt-svetelna-brana-rozsireni-nizsi-rocnik

### Možné řešení
Najdříve si zavoláme blok pro kalibraci a nastavení tolerance. Ta dovoluje číslo od 0 do 255 (čím větší tolerance, tím může dojít k většímu vychýlení od referenční hodnoty).
*💠 Takový ideální začátek je 50. Pokud žáci zhasnou zdroj světla nebo ho utlumí a nic se nestane, je potřeba snížit odchylku. Pokud naopak dojde k zobrazení naštvaného smajlíka a přehrání melodie v případě, kdy to nebylo zamýšleno, je potřeba zvýšit odchylku. 💠*

![Nastavení odchylky](https://github.com/pslib-cz/MP2021-22_Smutny-Jan_Algoritmizace-s-Micro-bit/blob/main/images/light%20gate/initialsetup.png?raw=true)

Nyní si vezmeme blok pro detekci porušení světelné závory a zvolíme si, co se má stát, když dojde k porušení.

![Spuštění kalibrace](https://github.com/pslib-cz/MP2021-22_Smutny-Jan_Algoritmizace-s-Micro-bit/blob/main/images/light%20gate/lightevent.png?raw=true)


## Vyšší ročník (složitejší varianta)
Vyšší ročníky budou mít za úkol naimplementovat přerušení hry.

### Rozšíření
#### Zkalibruj a nastav toleranci %tol
- Spustí kalibraci a nastaví toleranci
- Parametry:
    - tolerance (číslo)
- Bez návratové hodnoty

#### Při porušení hladiny světla
- Zkontroluje, jestli došlo k porušení hladiny světla
- Parametry:
    - metoda
- Bez návratové hodnoty

https://github.com/SmutnyJan/pxt-light-gate-advanced
https://github.com/microbit-cz/pxt-svetelna-brana-rozsireni-vyssi-rocnik

### Možné řešení
Nejdříve si založíme nějakou proměnnou, která bude představovat stav naší hry. Když zmáčkneme například tlačítko A, tak chceme, aby se hra zapnula/vypnula (zkrátka aby prohodila svůj stav). Pokud je potřeba hru zapnout, tak zavoláme blok „Zkalibruj a nastav toleranci“

![Prohazování stav hry](https://github.com/pslib-cz/MP2021-22_Smutny-Jan_Algoritmizace-s-Micro-bit/blob/main/images/light%20gate/gamestateswitch.png?raw=true)

A v zachytávání eventu chceme zvuk přehrát jen v moment, kdy máme hru zapnutou.

![Detekce hladiny světla](https://github.com/pslib-cz/MP2021-22_Smutny-Jan_Algoritmizace-s-Micro-bit/blob/main/images/light%20gate/eventadvanced.png?raw=true)


# Alarm

Tato úloha funguje jako alarm, který se spustí po zmačknutí tlačítka (nebo provedení jakéhokoli jiného vstupu). Alarm funguje cyklicky, což znamená, že pokud máme s dosahu microbity se správným programem (kódem), tak zapnutí alarmu pošle zprávu microbitům v okolím, že mají také spustit alarm (začít houkat). Tyto microbity to opět pošlou dál. Tímto způsobem se dá vytvořit takový „řetěz“. Alarm se poté dá i vypnout a to z jakéhokoli microbitu. Takže například na microbitu A zmáčkneme tlačítko. Microbit začne houkat a pošle microbitům v okolí zprávu, ať taky začnout houkat. Ty to opět pošlou dál. Zprávu dostane i microbit Z, na kterém zmáčkneme zase jiné tlačítko a tím alarm vypneme. Microbit Z tedy přestane houkat a pošle zprávu microbitům v okolí, aby taky přestaly houkat. Zpráva se nakonec dostane až k microbitu A, který původně alarm zapnul.

## Nižší ročník (jednodušší varianta)
Ve verzi pro nižší ročník se budou muset žáci vypořádat s zapínáním a vypínáním alarmu a poté se zpracováním pokynu, který může teoreticky přijít od jiného microbitu.

### Rozšíření
#### Při zapnutí alarmu
- Provede akci v moment, kdy je zapnutý alarm
- Parametry:
    - action (delegát)
- Bez návratové hodnoty

#### Spusť alarm a pošli pokyn || %message
- Spustí alarm a pošle všem zařízením v okolí pokyn ke spuštění alarmu (blok se dá rozšířit o vlastní parametr)
- Parametry:
    - message (nullable string)
- Bez návratové hodnoty

#### Vypni alarm a pošli pokyn || %message
- Vypne alarm a pošle všem zařízením v okolí pokyn k vypnutí alarmu (blok se dá rozšířit o vlastní parametr)
- Parametry:
    - message (nullable string)
- Bez návratové hodnoty

#### Přijmout pokyn %message
- Přijme pokyn od jiného zařízení, vrací true/false podle toho, jestli je alarm vypnutý nebo zapnutý Do parametrů se jednoduše přetáhnou argumenty z bloku „když je přijat text“
- Parametry:
    - name (text)
- Návratová hodnota: stav alarmu po přijetí pokynu (bool)

https://github.com/SmutnyJan/pxt-alarm
https://github.com/microbit-cz/pxt-alarm-rozsireni-nizsi-rocnik

### Možné řešení

*💠Žáci by měli z popisu zadání poznat, že se v této úloze opět využije rádio a tím pádem by se jich učitel mohl zeptat, co se musí nastavit, aby rádio správně fungovalo. Na mysli mám rádiovou skupinu. Tak, jako u předchozích úloh, se zde dá rádiová skupina použít při rozdělení do žáků skupin, ale myslím si, že to zde nebude nutné, protože při větších skupinách vynikne to, jak si spolu microbity budou povídat.💠*
Nejdříve si tedy nastavíme radiovou skupinu a můžeme na LED poli ukázat něco, co nám bude symbolizovat, že máme alarm vypnutý (alarm na začátku bude vždy vypnutý).

![Nastavení rádia](https://github.com/pslib-cz/MP2021-22_Smutny-Jan_Algoritmizace-s-Micro-bit/blob/main/images/alarm/initialsetup.png?raw=true)

Poté si zvolíme, jak chceme alarm zapínat a vypínat. Já jsem nebyl moc kreativní a zvolil jsem tlačítka A a B. Ve verzi pro nižší ročník si žáci vystačí se zkrácenou verzí obou bloků (nemají tedy klikat na ikonu plusu). Dále je dobré na displeji ukázat vhodný obrazec.

![Zapnutí alarmu](https://github.com/pslib-cz/MP2021-22_Smutny-Jan_Algoritmizace-s-Micro-bit/blob/main/images/alarm/turnonalarm.png?raw=true)
![Vypnutí alarmu](https://github.com/pslib-cz/MP2021-22_Smutny-Jan_Algoritmizace-s-Micro-bit/blob/main/images/alarm/turnoffalarm.png?raw=true)


Jako další věc musíme zajistit, že microbit bude přijímat pokyny od ostatních microbitů. K tomu použijeme blok ze sekce „rádio“. Potom si zavoláme blok „Přijmout pokyn“, který vrací true/false podle toho, jestli je alarm po přijetí zapnutý (true) nebo vypnutý (false). Výsledek si uložíme do proměnné a na základě její hodnoty zobrazíme příslušný obraz na LED poli.

![Přijmutí pokynu](https://github.com/pslib-cz/MP2021-22_Smutny-Jan_Algoritmizace-s-Micro-bit/blob/main/images/alarm/receivecommand.png?raw=true)

A jako poslední věc musíme zařídit, aby se něco stalo, když máme zapnutý alarm. S tím nám pomůže blok „Při zapnutí alarmu“.

![Event při zapnutí alarmu](https://github.com/pslib-cz/MP2021-22_Smutny-Jan_Algoritmizace-s-Micro-bit/blob/main/images/alarm/onalarm.png?raw=true)


*💠Učitel by se mohl žáků zeptat, čím zajistíme, že microbit nebude vůbec přijímat pokyny od ostatních microbitů. Odpověd by měla být, že odstraněním bloku „když je přijat text“.💠*

## Vyšší ročník (složitější varianta)
Vyšší ročník bude mít za úkol postarat se o zpracování pokynů přicházejících od jiných microbitů.

### Rozšíření
#### Při zapnutí alarmu
- Provede akci v moment, kdy je zapnutý alarm
- Parametry:
    - action (delegát)
- Bez návratové hodnoty

#### Spusť alarm a pošli pokyn || %message
- Spustí alarm a pošle všem zařízením v okolí pokyn ke spuštění alarmu (blok se dá rozšířit o vlastní parametr)
- Parametry:
    - message (nullable string)
- Bez návratové hodnoty

#### Vypni alarm a pošli pokyn || %message
- Vypne alarm a pošle všem zařízením v okolí pokyn k vypnutí alarmu (blok se dá rozšířit o vlastní parametr)
- Parametry:
    - message (nullable string)
- Bez návratové hodnoty
    
https://github.com/SmutnyJan/pxt-alarm-advanced
https://github.com/microbit-cz/pxt-alarm-rozsireni-vyssi-rocnik

### Možné řešení

Celé řešení je závislé na zvolení správného radio textu. Ve výsledku je to ale velice jednoduché. Komunikace probíhá pomocí bloku/metody „odešli text“. V mém případě posílám při zapínání text "alarm_on" a při vypínání text "alarm_off". A při přijímání používám odpovídající blok „když je přijat text %text“. Všichni žáci tedy musí mít stejný přijímací a odesílací text.

Nejdřívě si opět nastavíme radio a zobrazíme na displeji nějaký symbol. Poté si vytvoříme proměnné, do kterých uložíme oba texty. Proměnné nejsou samozřejmě nutností, ale předejde se zbytečným chybám. 
*💠Do proměnné se nahraje text pomocí bloku nastav -název proměnné- na nějaké číslo. Pokud ale nechceme číslo, musíme na místo čísla přetáhnout blok uvozovek ze sekce text (úplně první blok, musí se rozkliknout „rozšířené“).💠*

![Nastavení radia a proměnných](https://github.com/pslib-cz/MP2021-22_Smutny-Jan_Algoritmizace-s-Micro-bit/blob/main/images/alarm/initialsetupadvanced.png?raw=true)

Nyní si nastavíme zapínání/vysílání alarmu s posíláním pokynů. 

![Zapnutí alarmu](https://github.com/pslib-cz/MP2021-22_Smutny-Jan_Algoritmizace-s-Micro-bit/blob/main/images/alarm/turnonalarmadvanced.png?raw=true)
![Vypnutí alarmu](https://github.com/pslib-cz/MP2021-22_Smutny-Jan_Algoritmizace-s-Micro-bit/blob/main/images/alarm/turnoffalarmadvanced.png?raw=true)

K přijímání musíme logicky použít blok, který přijímá text. Na microbit nám může přijít cokoli, nás ale zájímají zprávy, které mají námi definovaný text (alarm_on/off). Pokud dostaneme „on“, zapneme alarm a dáme vědět ostatním. Pokud dostaneme „off“, alarm vypneme a také dáme vědět ostatním.

![Přijímání pokynů](https://github.com/pslib-cz/MP2021-22_Smutny-Jan_Algoritmizace-s-Micro-bit/blob/main/images/alarm/receivecommandadvanced.png?raw=true)

A jako poslední věc musíme zařídit, aby se něco stalo, když máme zapnutý alarm. S tím nám pomůže blok „Při zapnutí alarmu“.

![Event při zapnutí alarmu](https://github.com/pslib-cz/MP2021-22_Smutny-Jan_Algoritmizace-s-Micro-bit/blob/main/images/alarm/onalarm.png?raw=true)

# Hlasování 1/2 (volič) 
Tyto dvě úlohy dohromady zrealizují sběr jakýchkoli dat (hlasování). Na to bude potřeba jeden server („výběrčí dat“) a N hlasujících zařízení. Tato úloha je, jak nadpis napovídá, rozdělena na dvě části. V první části budeme tedy dělat hlasovací zařízení. Jelikož je prví část velice jednoduchá, tak bude jen jedna varianta pro oba ročníky.

### Rozšíření
Tato úloha je bez rozšíření.

### Možné řešení

Budeme komunikovat před rádio a tím pádem musíme nastavit skupinu rádia (opět možné skupiny žáků). Společně s hlasem chceme vysílat i sériové číslo, aby mohl být hlas jednoznačně identifikován.

![Nastavení skupiny rádia](https://github.com/pslib-cz/MP2021-22_Smutny-Jan_Algoritmizace-s-Micro-bit/blob/main/images/voting/voter/initialsetup.png?raw=true)

Úlohu budeme dělat tak, že každé zařízení bude mít 4 hlasovací možnosti. Serveru nebudeme posílat přímo jednu z možností, ale jen písmeno A, B, C a nebo D. Server si pak „přeloží“ písmeno na odpovídající možnost (ve verzi pro nižší ročník). Pak už stačí jen při patřičných vstupech odesílat hlasy. Dobré vylepšení je si na displeji rovnou zobrazit, jaký hlas microbit odeslal.

![Odeslání hlasu A](https://github.com/pslib-cz/MP2021-22_Smutny-Jan_Algoritmizace-s-Micro-bit/blob/main/images/voting/voter/votingaoption.png?raw=true)
![Odeslání hlasu B](https://github.com/pslib-cz/MP2021-22_Smutny-Jan_Algoritmizace-s-Micro-bit/blob/main/images/voting/voter/votingboption.png?raw=true)
![Odeslání hlasu C](https://github.com/pslib-cz/MP2021-22_Smutny-Jan_Algoritmizace-s-Micro-bit/blob/main/images/voting/voter/votingcoption.png?raw=true)
![Odeslání hlasu D](https://github.com/pslib-cz/MP2021-22_Smutny-Jan_Algoritmizace-s-Micro-bit/blob/main/images/voting/voter/votingdoption.png?raw=true)


# Hlasování 2/2 (server) 

Ve druhé částí hlasování bude za úkol udělat server (tzn. shromažďování hlasů).

## Nižší ročník (jednodušší varianta)

### Rozšíření
#### Nastav hlasovací hodnoty A: %a B: %b C: %c D: %d
- Nastaví samotný obsah hlasování (jestli chceme hlasovat například o barvě, zvířeti, čísle...)
- Parametry:
    - hodnota A (text)
    - hodnota B (text)
    - hodnota C (text)
    - hodnota D (text)
- Bez návratové hodnoty

#### Zobraz výsledky
- Zobrazí výsledky hlasování
- Bez parametrů
- Bez návratové hodnoty

#### Spusť nové hlasování
- Spustí nové hlasování a smaže uložená data
- Bez parametrů
- Bez návratové hodnoty


#### Zaznamenej hlas %hlas se seriovým číslem %serioveCislo
- Zaznamená nový hlas
- Parametry:
    - hlas (text)
    - seriové číslo (číslo)
- Bez návratové hodnoty
    
https://github.com/SmutnyJan/pxt-voting-collector
https://github.com/microbit-cz/pxt-server-rozsireni-nizsi-rocnik

### Možné řešení

Jako první si opět nastavíme rádio a přidružíme jednotlivým písmenům (A, B, C, D) nějaké možnosti. Například ANO, NE, NEVIM, MOZNA (tyto možnosti je potřeba hlasujícím říct).

![Nastavení rádia a hlasování](https://github.com/pslib-cz/MP2021-22_Smutny-Jan_Algoritmizace-s-Micro-bit/blob/main/images/voting/collector/initialsetup.png?raw=true)

Nyní se postaráme o zaznamenání každého hlasu, který nám přijde. Díky tomu, že jsme si na hlasovači povolili odesílání sériového čísla, ho můžeme získat přes blok „přijatý paket“. 

![Zaznamenání hlasu](https://github.com/pslib-cz/MP2021-22_Smutny-Jan_Algoritmizace-s-Micro-bit/blob/main/images/voting/collector/addvote.png?raw=true)

Nyní si nastavíme zobrazování dosavadních výsledků hlasování.

![Zobrazení výsledků](https://github.com/pslib-cz/MP2021-22_Smutny-Jan_Algoritmizace-s-Micro-bit/blob/main/images/voting/collector/showresults.png?raw=true)

A jako poslední zbývá zprovoznění spouštění nového hlasování.

![Spuštění nového hlasování](https://github.com/pslib-cz/MP2021-22_Smutny-Jan_Algoritmizace-s-Micro-bit/blob/main/images/voting/collector/newvoting.png?raw=true)

## Vyšší ročník (složitější varianta)
V těžší verzi budou k dispozici bloky pro zaznamenání hlasu a pro nové hlasování. Nebudou ale již přitomny bloky pro nastavení hlasovacích hodnot a pro zobrazení výsledků. Místo toho si budou muset žáci vystačit s blokem, který vrátí pole se zaznamenanými odpovědmi. 


### Rozšíření

#### Spusť nové hlasování
- Spustí nové hlasování a smaže uložená data
- Bez parametrů
- Bez návratové hodnoty

#### Zaznamenej hlas %hlas se seriovým číslem %serioveCislo
- Zaznamená nový hlas
- Parametry:
    - hlas (text)
    - seriové číslo (číslo)
- Bez návratové hodnoty

#### Získej odpovědi
- Vrátí pole se zaznamenanými odpověďmi (například pokud dostaneme pole ["A", "A", "B", "D"], znamená to, že máme celkem 4 hlasy: 2 × A, 1 × B, 0 × C, 1 × D)
- Bez parametrů
    
https://github.com/SmutnyJan/pxt-voting-collector-advanced
https://github.com/microbit-cz/pxt-server-rozsireni-vyssi-rocnik

### Možné řešení

Nejdříve si jako vždy nastavíme rádio.

![Nastavení rádia](https://github.com/pslib-cz/MP2021-22_Smutny-Jan_Algoritmizace-s-Micro-bit/blob/main/images/voting/voter/initialsetup.png?raw=true)

Přídávání hlasu a spuštění nového hlasování zůstane stejné, jako v jednodušší verzi.

![Zaznamenání hlasu](https://github.com/pslib-cz/MP2021-22_Smutny-Jan_Algoritmizace-s-Micro-bit/blob/main/images/voting/collector/addvote.png?raw=true)
![Spuštění nového hlasování](https://github.com/pslib-cz/MP2021-22_Smutny-Jan_Algoritmizace-s-Micro-bit/blob/main/images/voting/collector/newvoting.png?raw=true)

Jako poslední a nejkomplikovanější věc přichází na řadu zobrazení výsledků. Začneme tím, že si zvolíme, kdy se výsledky zobrazí. Já jsem si vybral tlačítko A. Poté si založíme pět proměnných. Jednu, která v sobě bude držet seznam odpovědí a čtyři pro každou hlasovací možnost. Ty v sobě budou mít vždy informaci, kolikrát byla jaká možnost zaznamenána. 
Proměnnou odpovedi tedy nastavím na pole, které mi vrátí blok „Získej odpovědi“. A proměnné pocetA, pocetB pocetCa pocetDvždy vynuluji, protože v proměnných nechci mít uložená data, která tam mohla zůstat z předchozího vypsání. Nyní si projdu pole odpovedi a pro každý prvek se rozhodnu, jakou proměnnou zrovna zvýším. Pokud mám zrovna znak A, znamená to, že se jedná o hlas A a tím pádem zvýším o 1 proměnnou pocetA. Analogicky to tak provedu u ostatních proměnných. Jako poslední věc si výsledky vypíšu (blok „spoj“ se schovává pod sekcí text, která zobrazí po rozkliknutí rozšířených sekcí).

![Vypsání hlasů](https://github.com/pslib-cz/MP2021-22_Smutny-Jan_Algoritmizace-s-Micro-bit/blob/main/images/voting/collector/showresultsadvanced.png?raw=true)

*💠Když žáci udělají výpis tak, jako já, zjistí, že se jim nevypisuje textová možnost (ANO/NE/MOZNA/NEVIM), ale jen A/B/C/D. Žáci by mohli dostat za úkol zjistit, proč to tak je a popřípadě to opravit... Je to kvůli tomu, že spojuji "A" s počtem hlasů, "B" s počtem hlasů atd. Problém by se vyřešil tak, že by se místo textů "A", "B", "C", "D" napsalo do „spoj“ přímo ANO/NE/MOZNA/NEVIM (nebo jakékoli jiné možnosti)💠*

![Lepší vypsání hlasů](https://github.com/pslib-cz/MP2021-22_Smutny-Jan_Algoritmizace-s-Micro-bit/blob/main/images/voting/collector/showresultsadvancedbetter.png?raw=true)

# Balancování

Tato úloha bude taková oddechovější a i když v ní nepůjde tak úplně o programování (alespoň v jednodušší verzi), tak si myslím, že by mohlo být o zábavu postaráno. Úloha by měla simulovat hru „vajíčko na lžičce“. Představoval bych si tedy to, že se žáci například rozdělí do dvou skupin, každá skupina bude mít jeden microbit s úlohou a úkolem obou týmů bude přejít z bodu A do bodu B, poté se opět vrátit do bodu A, kde budou čekat ostatní žáci ze skupiny. Žák, který zrovna šel předá microbit dalšímu žákovi, který opět půjde z bodu A do bodu B a zpět. Pokud se stane, že by při cestě microbit detekoval „spadnutí vejce“, musí se žák vrátit do bodu A a opět jít do bodu B a zpět. Vyhrává ta skupina, která toto zvládne nejrychleji. 

## Nižší ročník (jednodušší varianta)
Jak již bylo řečeno, úloha pro nižší ročník bude velice primitivní. Asi ani nevím, jak bych řešení okomentoval.

### Rozšíření

#### Spusť hru s obtížností %obtiznost
- Spustí hru s obtížností
- Parametry:
    - obtiznost (enum)
- Bez návratové hodnoty

#### Aktualizuj
- Aktualizuje LEDky
- Bez parametrů
- Bez návratové hodnoty

#### Při pádu vejce
- Zkontroluje, jestli vejce nespadlo
- Parametry:
    - metoda
- Bez návratové hodnoty
    
https://github.com/SmutnyJan/pxt-spoon-balancing
https://github.com/microbit-cz/pxt-vejce-na-lzici-rozsireni-nizsi-rocnik

### Možné řešení

Jednoduše si při nějakém vstupu spustíme hru a ve smyčce „opakuj stále“ budeme aktualizovat LEDky. Při nějakém vstupu si pustíme hru. Obtížnost hry určuje, jak moc složité je s Microbitem pohybovat aniž by „vejce spadlo“. A nakonec máme k dispozici event „Při pádu vejce“, který určuje, co se má stát, když vejce spadne.

![Spuštění hry](https://github.com/pslib-cz/MP2021-22_Smutny-Jan_Algoritmizace-s-Micro-bit/blob/main/images/balancing/turnongame.png?raw=true)
![Aktualizace souřadnic](https://github.com/pslib-cz/MP2021-22_Smutny-Jan_Algoritmizace-s-Micro-bit/blob/main/images/balancing/update.png?raw=true)
![Pád vejce](https://github.com/pslib-cz/MP2021-22_Smutny-Jan_Algoritmizace-s-Micro-bit/blob/main/images/balancing/egghasfallen.png?raw=true)


## Vyšší ročník (složitější varianta)
Složitější varianta bude vskutku složitější. Žáci si opět procvičí práci s polem a zkusí si vytvořit trochu složitější if. K dispozici bude z rozšíření blok na spuštění nové hry, ale nebude jž k dispozici blok na aktualizaci. Místo toho bude k dispozici blok, který vrátí pole, které bude obsahovat aktuální souřadnice (například [2, 3]). Bude tedy potřeba udělat to, aby microbit nějak zareagoval, když budou souřadnice v nepovolených hodnotách. Dále bude potřeba zajistit to, aby se souřadnice nepřekreslovaly, když nechceme.

### Rozšíření

#### Spusť hru s obtížností %obtiznost
- Spustí hru s obtížností
- Parametry:
    - obtiznost (enum)
- Bez návratové hodnoty

#### Souřadnice
- Vrátí aktuální souřadnice
- Bez parametrů
- Návratová hodnota: pole souřadnic (number[])
    
https://github.com/SmutnyJan/pxt-spoon-balancing-advanced
https://github.com/microbit-cz/pxt-vejce-na-lzici-rozsireni-vyssi-rocnik

### Možné řešení

Začneme tím, že si vytvoříme proměnnou, která v sobě bude mít stav hry (jestli je zapnutá nebo vypnutá). V začátku bude hra vypnutá a tím pádem nastavíme proměnnou na false.

![Vytvoření proměnné](https://github.com/pslib-cz/MP2021-22_Smutny-Jan_Algoritmizace-s-Micro-bit/blob/main/images/balancing/initialsetup.png?raw=true)

Zapnutí hry také nebude nic slozitého. Nastavíme proměnnou na spuštění hry na true a použijeme blok z rozšíření, který zapne hru.

![Zapnutí hry](https://github.com/pslib-cz/MP2021-22_Smutny-Jan_Algoritmizace-s-Micro-bit/blob/main/images/balancing/turnongameadvanced.png?raw=true)

Smyčku „opakuj stále“ jsem rozdělil na dva obrázky. Nejdříve si zkontrolujeme, zdali máme hru spuštěnou. Pokud ano, tak nastavíme proměnnou souradnice (je potřeba si ji vytvořit) na souřadnice, které nám vrátí blok z rozšíření. 

*💠Zde by se hodilo vysvětlení, proč je možné psát pouze jeHraSpustena a ne jeHraSpustena == true.💠*

![První část smyčky](https://github.com/pslib-cz/MP2021-22_Smutny-Jan_Algoritmizace-s-Micro-bit/blob/main/images/balancing/loop1of2.png?raw=true)

Druhá část smyčky bude už trochu složitější. Bude v ní jeden velký if, který zkontroluje, zda je hra spuštěná a jestli náhodou není jedna ze souřadnic 0 nebo 4 (oba extrémy, které znamenají, že vejce spadlo). Pokud jedna z podmínek bude platit, znamená to, že vejce spadlo. Můžeme tedy zobrazit například rozzlobeného smajlíka, přehrát nějaký zvuk a hlavně vypnout hru kterou zapneme tak, že zmáčkneme tlačítko A (v mém případě).

![Druhá část smyčky](https://github.com/pslib-cz/MP2021-22_Smutny-Jan_Algoritmizace-s-Micro-bit/blob/main/images/balancing/loop2of2.png?raw=true)

Smyčku je nejlepší udělat tak, že si vezmeme blok „když“ a na místo, kde je „pravda“, dáme blok „nebo“, což nám vytvoří dvě místa na další podmínky. Na tyto dvě místa dáme znovu „nebo“ a máme hotovo. Pak už můžeme prázdná místa vyplnit bloky pro zjištění hodnot na indexech 0 a 1 a porovnat tyto hodnoty s 0 a 4.

# Mikádo/hlídač věcí
Tato úloha bude fungovat jako takový strážce věcí. Pokud se microbit pohne, zahouká (proto mikádo). Obtížnost opět půjde nastavit parametrem.

## Nižší ročník (jednodušší varianta)
Zadání pro nižší ročník bude poměrně složité. Nejspíš nejsložitější ze všech.

### Rozšíření

#### Při porušení senzoru s obtížnost %obtiznost
- Zkontroluje, jestli nedošlo k pohybu
- Parametry:
    - obtížnost (enum)
    - metoda
- Bez návratové hodnoty

https://github.com/SmutnyJan/pxt-mikado
https://github.com/microbit-cz/pxt-mikado-rozsireni-nizsi-rocnik

### Možné řešení

Z rozšíření máme k dispozici pouze pouze blok, který něco provede, když dojde k pohybu. Dovoluje navíc i nastavení obtížnosti celé hry. Začneme nejdříve tím, že si založíme proměnnou, která v sobě bude držet stav hry (zapnuto/vypnuto). Mezi stavy si bude možno přepínat. Já jsem to vyřešil takhle:

![Změna stavu hry](https://github.com/pslib-cz/MP2021-22_Smutny-Jan_Algoritmizace-s-Micro-bit/blob/main/images/mikado/changestate.png?raw=true)

Nyní použijeme blok z rozšíření. Do něho ale nemůžeme dát jen to, co se má stát, když dojde k vychýlení. Musíme zkontrolovat, jestli máme hru zapnutou (if jeZapnutoHlidani == true). V tomto ifu můžeme již ukázat něco na displeji nebo přehrát zvuk. V bloku ještě pracuji s proměnnou jeProvadenaAkce, ke které se dostanu později. 

![Detekce pohybu](https://github.com/pslib-cz/MP2021-22_Smutny-Jan_Algoritmizace-s-Micro-bit/blob/main/images/mikado/checkmovement.png?raw=true)

Teď nám zbývá něco dokola provádět, když je senzor v klidu a nebo když nemáme hru vůbec zapnutou. Pokud je tedy proměnná jeZapnutoHlidani false, můžeme jednoduše ukázat veselého smajlíka („hlídač je v klidu“). Když je hlídání zapnuto, tak ukážeme ostražitého smajlíka. A zde přichází na řadu proměnná jeProvadenaAkce. Smyčka opakuj stále a kontrola senzoru se provádí paralelně. Pokud je tedy detekován pohyb, ukáže se smutný smajlík a přehraje se zvuk. V tu ránu přijde ale na řadu smyčka opakuj stále a smutného smajlíka ihned změní zase na ostražitého. Zvuk tedy sice uslyšíme, ale smutného smajlíka uvidíme jen na zlomek vteřiny. A právě proto máme proměnnou jeProvadenaAkce. Tu nastavíme na true v moment, kdy dojde k detekci pohybu a na false v moment, kdy dokončíme provádění instrukcí v tomto bloku. V mém příkladě mám přehrání zvuku, které nějakou chvíli trvá. jeProvadenaAkce se tedy nastaví na false v moment, kdy dohraje zvuk. A během těch chvil se nám ostražitý smajlík neukáže, protože máme jeProvadenaAkce na true a my máme v podmínce uvedeno, že na to, aby se ostražitý smajlík ukázal, musí být jeProvadenaAkce false.

![Smyčka na ukazování smajlíků](https://github.com/pslib-cz/MP2021-22_Smutny-Jan_Algoritmizace-s-Micro-bit/blob/main/images/mikado/loop.png?raw=true)

To ale není vše. Při vyzkoušení programu žáci zjistí, že kontrola probíhá poměrně pomalu. Hýbnou Microbitem a naštvaný smajlík se jim ukáže až na několik chvil. Je to tím, že dokola ve smyčce opakuj stále zobrazujeme ostražitého smajlíka. Rychlost smyčky je pěkně vidět v moment, když si úplně nahoru dáme do smyčky ze sekci série (musí se rozkliknout rozšířené) zapsání na řádek. Je úplně jedno, co si vypíšeme. Stačí například slovo „test“. Poté se nám v prostředí makecode objeví pod virtuálním microbitem zobrazit konzoli. Po kliknutí na tuto možnost zjistíme, že se smyčka provádí velice pomalu. Když si zkusíme ze smyčky vše odebrat (až na seriové vypsání), zjistíme, že je smyčka ve skutečnosti daleko rychlejší. Brzdí ji vypisování na displej. My ale na displej nemusíme vypisovat pořád dokola. Stačí vždy v moment, kdy se něco stane (vypneme/zapneme hru, dojde k detekci pohybu,...). Na vyřešení problému si vytvoříme další proměnnou s názvem stavDispleje. Když zobrazíme veselého smajlíka, nastavíme si stav například na „vesely“. Když budeme zobrazovat smajlíka v pozoru, nastavíme si proměnnou na hodnotu „pozor“ a když budeme zobrazovat naštvaného smajlíka, nastavíme si hodnotu na „naštvaný“. No a poté stačí tennto stav proměnných využít ve vypisování smajlíků. Když by se měl zobrazit veselý smajlík, tak nejdříve zkontrolujeme, jestli náhodou již nejsme ve stavu, kdy by byl zobrazen. V tu chvíli ho nechceme znovu zobrazovat, protože tím nechceme microbit zatěžovat. V moment, kdy smajlíka zobrazíme, si ale proměnnou nastavíme na stav vesely.

![Vylepšená smyčka na ukazování smajlíků](https://github.com/pslib-cz/MP2021-22_Smutny-Jan_Algoritmizace-s-Micro-bit/blob/main/images/mikado/loopbetter.png?raw=true)
![Smyčka na ukazování smajlíků](https://github.com/pslib-cz/MP2021-22_Smutny-Jan_Algoritmizace-s-Micro-bit/blob/main/images/mikado/checkmovementbetter.png?raw=true)


## Vyšší ročník (složitější varianta)
Složitější varianta bude obsahovat pouze jeden blok, který žákům vrátí klidovou hodnotu senzoru.

### Rozšíření

    
#### Klidová hodnota
- Vrátí klidovou hodnotu senzoru (číslo 1023)
- Bez parametrů
- Bez návratové hodnoty


https://github.com/SmutnyJan/pxt-mikado-advanced
https://github.com/microbit-cz/pxt-mikado-rozsireni-vyssi-rocnik

### Možné řešení

Začátek bude stejný jako u jednodušší verze. To zůstane beze změn.

![Změna stavu hry](https://github.com/pslib-cz/MP2021-22_Smutny-Jan_Algoritmizace-s-Micro-bit/blob/main/images/mikado/changestate.png?raw=true)

Teď je si ale musíme vytvořit funkci, která nám nahradí detekci pohybu. Funkce bude mít parametr, který bude značit dovolenou odchylku od klidové hodnoty. Zrychlení zjistíme pomocí bloku „zrychlení“, kde si z rozevíracího listu vybereme „síla“. No a nyní to vše poskládáme dohromady. Pokud ke zrychlení přičteme naší toleranci a z toho nám vyjde číslo, které je menší než klidová hodnota, došlo k pohybu. A nebo pokud od zrychlení odečteme toleranci a stále budeme mít číslo větší než klidová hodnota, tak také došlo k pohybu. V obou případech funkce vrátí true. Pokud ale neplatí ani jedno, vrátíme false. 

![Funkce na detekci pohybu](https://github.com/pslib-cz/MP2021-22_Smutny-Jan_Algoritmizace-s-Micro-bit/blob/main/images/mikado/movementdetection.png?raw=true)

Nyní si vezme smyčku opakuj stále, ve které budou tři ify (přesněji řešeno jeden if a dva if else). Budu vycházet z vysvětlení u předchozí verze (pro nižší ročník), takže už nebudu vysvětlovat zapínání/vypínání hry a stavDispleje. V prvním ifu si tedy ověříme, jestli byl detekován pohyb, jestli je zapnuto hlídání a jestli jíž náhodou nezobrazujeme naštvaného smajlíka. Pokud všechny podmínky platí (pohyb, je zapnutá hra, nezobrazujeme smajlíka), nastavíme si proměnnou stav displeje na „nastvany“, ukážeme rozzloveného smajlíka a přehrajeme zvuk. Pokud nedošlo k pohybu, je zapnuto hlídání a ještě nezobrazujeme ostražitého smajlíka, zobrazíme ho a nahrajeme si příšlušný stav do proměnné. A jako poslední si zkontrolujeme, jestli máme hru vypnutou a jestli již náhodou nezobrazujeme štastného smajlíka. Pokud ano, uděláme to a do proměnné stavDispleje nahrajeme text stastny.

![Smyčka využívající vytvořenou funkci](https://github.com/pslib-cz/MP2021-22_Smutny-Jan_Algoritmizace-s-Micro-bit/blob/main/images/mikado/loopwithownfunction.png?raw=true)

